import sys, os, base64, datetime, hashlib, hmac 
import requests

class AWSIGNER:
  
  aws_signer_service  = None
  api_credentials = None

  def set_api_credentials(self, api_credentials):
      self.api_credentials = api_credentials

  def make_signed_request(self, host, service_path, method, body):
    service = 'execute-api'
    region = 'us-east-1'
    endpoint = 'https://' + host  +service_path
    content_type = 'application/json'
    request_parameters = body

    api_key = self.api_credentials['api_key'] #'7NaZOnbqUf7oWtP4xJWpJHGtJqqISLu899nBJKQc'
    access_key = self.api_credentials['access_key'] #'AKIASSSPECJGIBIR6QU5'
    secret_key = self.api_credentials['secret_key'] #'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'

    if access_key is None or secret_key is None:
      print('No access key is available.')
      sys.exit()

    _dt_now = datetime.datetime.utcnow()
    amz_date = _dt_now.strftime('%Y%m%dT%H%M%SZ')
    date_stamp = _dt_now.strftime('%Y%m%d')
    canonical_uri = service_path
    canonical_querystring = ''
    canonical_headers = 'content-type:' + content_type + '\n' + 'host:' + host + '\n' + 'x-api-key:' + api_key + '\n'
    signed_headers = 'content-type;host;x-api-key'
    payload_hash = hashlib.sha256(request_parameters.encode('utf-8')).hexdigest()
    canonical_request = method + '\n' + canonical_uri + '\n' + canonical_querystring + '\n' + canonical_headers + '\n' + signed_headers + '\n' + payload_hash
    algorithm = 'AWS4-HMAC-SHA256'
    credential_scope = date_stamp + '/' + region + '/' + service + '/' + 'aws4_request'
    string_to_sign = algorithm + '\n' +  amz_date + '\n' +  credential_scope + '\n' +  hashlib.sha256(canonical_request.encode('utf-8')).hexdigest()
    signing_key = self.getSignatureKey(secret_key, date_stamp, region, service)
    signature = hmac.new(signing_key, (string_to_sign).encode('utf-8'), hashlib.sha256).hexdigest()
    authorization_header = algorithm + ' ' + 'Credential=' + access_key + '/' + credential_scope + ', ' +  'SignedHeaders=' + signed_headers + ', ' + 'Signature=' + signature

    headers = {
                'Content-Type':content_type,
                'x-amz-date':amz_date,
                'x-api-key':api_key,
                'Authorization':authorization_header
              }
    print(headers)
    print(request_parameters)
    print(endpoint)
    r = requests.post(endpoint, data=request_parameters, headers=headers)
    return r.text


  def sign(self, key, msg):
      return hmac.new(key, msg.encode("utf-8"), hashlib.sha256).digest()

  def getSignatureKey(self, key, date_stamp, regionName, serviceName):
      kDate = self.sign(('AWS4' + key).encode('utf-8'), date_stamp)
      kRegion = self.sign(kDate, regionName)
      kService = self.sign(kRegion, serviceName)
      kSigning = self.sign(kService, 'aws4_request')
      return kSigning