import datetime
import json
from . aws_signer import AWSIGNER

class NQINTERFACE:
	host='a7zgalw2j0.execute-api.us-east-1.amazonaws.com'
	channel = None
	client_id = None
	service_region = 'C001'
	service_version = '1.4.0'
	api_credentials = None
	aws_signer_service  = None

	def set_api_credentials(self, api_credentials):
		self.api_credentials = api_credentials
		self.aws_signer_service  = AWSIGNER()
		self.aws_signer_service.set_api_credentials(self.api_credentials)
	
	def set_service_version(self, version):
		self.service_version = version
	
	def set_service_region(self, region):
		self.service_region = region
	
	def set_channel(self, channel):
		self.channel = channel
	
	def set_client_id(self, client_id):
		self.client_id = client_id
	
	def validate_client(self,phone_number,value):
		service_path = '/qa/-services-clientservice-validateclient'
		body = self.get_body_validate_client(phone_number, value)
		response = self.aws_signer_service.make_signed_request(self.host, service_path, 'POST', body)
		return response
	
	def payment_request(self,code, phone_number,value, reference):
		service_path = '/qa/-services-paymentservice-unregisteredpayment'
		body = self.get_body_payment_request(code, phone_number, value, reference)
		response = self.aws_signer_service.make_signed_request(self.host, service_path, 'POST', body)
		return response

	def cash_in_client(self,phone_number,value):
		response = None
		service_path = "/-services-cashinservice-cashin"
		body = self.get_body_cash_in_client(phone_number, value)		
		response = self.aws_signer_service.make_signed_request(self.host,service_path,"POST",body)
		return response

	def get_body_validate_client(self, phone_number, value):
		_dt_now = datetime.datetime.utcnow()
		date_stamp = _dt_now.strftime('%Y%m%d')

		message_id = date_stamp
		request_date = date_stamp

		validateClientRQ={}
		validateClientRQ['phoneNumber'] = phone_number
		validateClientRQ['value'] = value

		any_arr={}
		any_arr['validateClientRQ']=validateClientRQ

		RequestBody={}
		RequestBody['any']=any_arr

		Destination={}
		Destination['ServiceName'] = 'RechargeService'
		Destination['ServiceOperation'] = 'validateClient'
		Destination['ServiceRegion'] = self.service_region
		Destination['ServiceVersion'] = self.service_version

		RequestHeader={}
		RequestHeader['Channel'] = self.channel
		RequestHeader['RequestDate'] = request_date
		RequestHeader['MessageID'] = message_id
		RequestHeader['ClientID'] = self.client_id
		RequestHeader['Destination'] = Destination

		RequestMessage={}
		RequestMessage['RequestHeader'] = RequestHeader
		RequestMessage['RequestBody'] = RequestBody

		nequi_body={}
		nequi_body['RequestMessage'] = RequestMessage

		json_nequi_body = json.dumps(nequi_body)
		return json_nequi_body

	def get_body_cash_in_client(self, phone_number, value, nit_code='001'):
		message_id = str(datetime.timestamp(datetime.now()))[0:9]
		request_date = str(datetime.now())[0:10]

		cashInRQ = {}
		cashInRQ['phoneNumber'] = phone_number
		# Ccode: NIT del comercio en donde se esta haciendo la recarga
		cashInRQ['code'] = nit_code
		cashInRQ['value'] = value

		any_arr = {}
		any_arr['cashInRQ'] = cashInRQ

		RequestBody = {}
		RequestBody['any'] = any_arr

		Destination = {}
		Destination['ServiceName'] = 'CashInService'
		Destination['ServiceOperation'] = 'cashIn'
		Destination['ServiceRegion'] = self.service_region
		Destination['ServiceVersion'] = '1.0.0'

		RequestHeader = {}
		RequestHeader['Channel'] = self.channel
		RequestHeader['RequestDate'] = request_date
		RequestHeader['MessageID'] = message_id
		RequestHeader['ClientID'] = self.client_id
		RequestHeader['Destination'] = Destination

		RequestMessage = {}
		RequestMessage['RequestHeader'] = RequestHeader
		RequestMessage['RequestBody'] = RequestBody

		nequi_body = {}
		nequi_body['RequestMessage'] = RequestMessage

		json_nequi_body = json.dumps(nequi_body)
		return json_nequi_body
	
	def get_body_payment_request(self, code, phone_number, value, reference):
		_dt_now = datetime.datetime.utcnow()
		date_stamp = _dt_now.strftime('%Y%m%d')

		message_id = date_stamp
		request_date = date_stamp

		unregisteredPaymentRQ = {}
		unregisteredPaymentRQ['phoneNumber'] = phone_number
		unregisteredPaymentRQ['code'] = code
		unregisteredPaymentRQ['value'] = value
		unregisteredPaymentRQ['reference1'] = reference

		any_arr = {}
		any_arr['unregisteredPaymentRQ'] = unregisteredPaymentRQ

		RequestBody={}
		RequestBody['any'] = any_arr

		Destination = {}
		Destination['ServiceName'] = 'PaymentsService'
		Destination['ServiceOperation'] = 'unregisteredPayment'
		Destination['ServiceRegion'] = self.service_region
		Destination['ServiceVersion'] = self.service_version

		RequestHeader = {}
		RequestHeader['Channel'] = self.channel
		RequestHeader['RequestDate'] = request_date
		RequestHeader['MessageID'] = message_id
		RequestHeader['ClientID'] = self.client_id
		RequestHeader['Destination'] = Destination

		RequestMessage = {}
		RequestMessage['RequestHeader'] = RequestHeader
		RequestMessage['RequestBody'] = RequestBody

		nequi_body = {}
		nequi_body['RequestMessage'] = RequestMessage

		json_nequi_body = json.dumps(nequi_body)
		return json_nequi_body