import json
import sys
from . interface import NQINTERFACE


class Service:
    api_credentials = None
    nq_interface = None

    def set_api_credentials(self, api_credentials):
        self.api_credentials = api_credentials
        self.nq_interface = NQINTERFACE()

    def set_client_id(self, client_id):
        self.nq_interface.set_client_id(client_id)

    def set_channel(self, channel):
        self.nq_interface.set_channel(channel)

    def user_validation(self, params):

        self.nq_interface.set_api_credentials(self.api_credentials)
        response = self.nq_interface.validate_client(params['phone'], params['value'])
        return response

    def payment_request(self, params):

        self.nq_interface.set_api_credentials(self.api_credentials)
        response = self.nq_interface.payment_request(params['code'], params['phone'], params['value'], params['reference'])
        return response
